package com.djhk.uav.label.mapper;


import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.djhk.uav.label.domain.FolderInfo;
import com.djhk.uav.label.domain.vo.FolderVo;
import com.djhk.uav.label.query.FolderTreeQuery;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 目录信息Mapper接口
 *
 * @author myk
 * @date 2023-07-22
 */
public interface FolderInfoMapper extends BaseMapper<FolderInfo>
{
    /**
     * 查询目录信息
     *
     * @param id 目录信息主键
     * @return 目录信息
     */
    public FolderInfo selectFolderInfoById(Long id);

    /**
     * 查询目录信息列表
     *
     * @param folderInfo 目录信息
     * @return 目录信息集合
     */
    public List<FolderInfo> selectFolderInfoList(FolderInfo folderInfo);

    /**
     * 新增目录信息
     *
     * @param folderInfo 目录信息
     * @return 结果
     */
    public int insertFolderInfo(FolderInfo folderInfo);

    /**
     * 修改目录信息
     *
     * @param folderInfo 目录信息
     * @return 结果
     */
    public int updateFolderInfo(FolderInfo folderInfo);

    /**
     * 删除目录信息
     *
     * @param id 目录信息主键
     * @return 结果
     */
    public int deleteFolderInfoById(Long id);

    /**
     * 批量删除目录信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteFolderInfoByIds(Long[] ids);

    List<String> selectLockFolderNames(@Param("ids") List<Long> ids);

    List<FolderVo> queryFolderVos(FolderTreeQuery query);

    List<FolderVo> findFirstParentFolders(@Param("ids") List<Long> ids);

    List<Long> selectIdsByParentIds(@Param("parentIds") List<Long> parentIds);

    List<String> selectHaveLockPlottingFolders(@Param("ids") List<Long> allIds);

    List<FolderInfo> selectSelfAndChildren(@Param("id") Long id);

    int batchUpdateShowStatusApp(@Param("ids") List<Long> ids, @Param("showStatusApp") Integer showStatusApp);

    int batchUpdateShowStatusWeb(@Param("ids") List<Long> ids, @Param("showStatusWeb") Integer showStatusWeb);

    int batchUpdateShareStatus(@Param("ids")List<Long> ids, @Param("shareStatus")Integer shareStatus);

    int changeLockStatus(@Param("ids") List<Long> ids, @Param("lockStatus") Integer lockStatus);
}
